#!/usr/bin/perl

# This is a blatant hack to calculate fake frame rates to compensate for
# timing errors where necessary.

$base_fps = ($ARGV[0] || 25);

while (<STDIN>) {
  chomp;
  if (/^STAT: Processing vobs\/(.*)\.\.\.$/) {
    $name = $1;
  } elsif (/^INFO: Video pts = ([\d.]+) \.\. ([\d.]+)$/) {
    ($vbegin, $vend) = ($1, $2);
  } elsif (/^INFO: Audio\[0\] pts = ([\d.]+) \.\. ([\d.]+)$/) {
    ($abegin, $aend) = ($1, $2);
    # If synch is more than a quarter second out by the end, fix it.
    if (abs(($aend - $abegin) - ($vend - $vbegin)) > 0.25) {
      printf "\$(BUILD_DIR)/%s : MENCODER_FLAGS += -fps %.3f\n",
        $name, $base_fps * ($vend - $vbegin) / ($aend - $abegin);
    }
  }
}
